int main(void)
{
    /* Initialized data */
    static float delta[41] = { .001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,
            .001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,
            .001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,
            .001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f,.001f 
            };
    static float hx[41] = { .1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,
            .1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,
            .1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,.1f,0.f };
    static float hy[41] = { .05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,
            .05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,
            .05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,.05f,
            .05f,.05f,.05f,.05f,0.f };
    static float v1[41] = { 0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
            0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,100.f,100.f,100.f,100.f,100.f,
            100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,
            100.f,100.f,100.f,100.f,0.f };
    static float v2[41] = { 100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,
            100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,100.f,
            100.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
            0.f,0.f,0.f,0.f,0.f,0.f };
    static int mu[41] = { 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0 };
    static float up[41] = { 0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
            0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,
            0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f,0.f };

    /* Builtin functions */
    double atan(double), log(double);

    /* Local variables */
    extern int ef04r_c(int *, int *, float *, float *,
            float *, float *, int *, float *, float *, int *, float *,
            float *, float *, float *);
    static float a[1681] /* was [41][41] */, b[619], f[41];
    static int i__, i, j, k, m, n;
    static float p, u[41], w, w1;
    static int ng;
    int i__1, i__2;
    float r__1;

#define a_ref(a_1,a_2) a[(a_2)*41 + a_1 - 42]

    p = 1.f;
    ng = 3;
    m = 41;
    n = 41;
    b[0] = -2.f;
    b[m] = -1.f;
    i__1 = n;
    for (j = 2; j <= i__1; ++j) {
        k = m + j;
        v1[j - 2] = -v1[j - 2];
        mu[j - 2] = -mu[j - 2];
/* L1: */
        b[k - 1] = b[k - 2] + hy[j - 2];
    }
    i__1 = m;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* L2: */
        b[i__ - 1] = b[i__ - 2] + hx[i__ - 2];
    }
    i__1 = m;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i__2 = n;
        for (j = 1; j <= i__2; ++j) {
            k = m + j;
/* Computing 2nd power */
            r__1 = b[k - 1] - b[i__ - 1];
            a_ref(i__, j) = 1.f / (r__1 * r__1 + 1.f);
/* L4: */
        }
    }
    i__2 = m;
    for (i__ = 1; i__ <= i__2; ++i__) {
        w = b[i__ - 1] + 1.f;
        w1 = 1.f - b[i__ - 1];
        f[i__ - 1] = (w * w1 + 1.f) * ((float)atan(w) + (float)atan(w1)) -
                2.f - b[i__ - 1] * (float)log((float)((w1 * w1 + 1.f) /
                (w * w + 1.f)));
/* L5: */
    }
    ef04r_c(&m, &n, a, f, delta, &p, &ng, v1, v2, mu, hy, up, u, b);

    for (i = 0; i <= 36; i+= 4) {
     printf("\n %16.7e %16.7e %16.7e %16.7e ",u[i], u[i+1], u[i+2], u[i+3]);
    }
    printf("\n %16.7e \n",u[40]);
    return 0;
} /* main */

#undef a_ref
